diff -r ad2ebc237570 src/login-common/ssl-proxy-openssl.c
--- a/src/login-common/ssl-proxy-openssl.c	Tue Oct 25 21:44:38 2011 +0300
+++ b/src/login-common/ssl-proxy-openssl.c	Tue Oct 25 21:46:38 2011 +0300
@@ -805,6 +805,13 @@
 
 	proxy = SSL_get_ex_data(ssl, extdata_index);
 
+	if (where == SSL_CB_HANDSHAKE_START && proxy->handshaked) {
+		i_warning("SSL renegotiation prevented from %s",
+			  net_ip2addr(&proxy->ip));
+		ssl_proxy_destroy(proxy);
+		return;
+	}
+
 	if (!proxy->set->verbose_ssl)
 		return;
 
